寒假222_codeforces 290 div 2 D

序号:

想了很久的DP ,应该很简单,但是。。

题目直接转化为求n个数中选一些数GCD=1且花费最小

数比较大

map  HASH

还有一点 我们知道 GCD(X,X*Y)==X;

所以我的代码里不用考虑这点了

pasting

#include<stdio.h>
#include<algorithm>
#include<string>
#include<iostream>
#include<queue>
#include<cmath>
#include<string.h>
#include <vector>
#include<map>
using namespace std;
typedef long long ll;
map<int,int>mp;
int a[333],b[333];
#define inf 0x3f3f3f3f

map<int,int>::iterator it;

int gcd(int x,int y)
{
    if (x%y==0) return y;
    return gcd(y,x%y);
}

void dfs(int x,int y)
{
    if (!mp[x]) mp[x]=inf;
    mp[x]=min(mp[x],y);
    for (it=mp.begin();it!=mp.end();it++)
    {
        int tmp=(*it).first;
        int v=  (*it).second;
        int nw=gcd(tmp,x);
        if (!mp[nw]) mp[nw]=inf;
        mp[nw]=min(mp[nw],v+y);
    }
}

int main()
{
    int n;
    cin>>n;
    for (int i=1;i<=n;i++) cin>>a[i];
    for (int i=1;i<=n;i++) cin>>b[i];

        for (int i=1;i<=n;i++)
        dfs(a[i],b[i]);
        if (mp[1]==0) mp[1]=-1;
        cout<<mp[1];
    return 0;
}
				
时间: 2024-10-08 09:58:40

寒假222_codeforces 290 div 2 D的相关文章

Codeforces Round #290 (Div. 2) b

/** * @brief Codeforces Round #290 (Div. 2) b * @file a.cpp * @author mianma * @created 2015/02/04 15:17 * @edited 2015/02/04 15:17 * @type brute * @note */ #include <fstream> #include <iostream> #include <string> #include <cstring>

Codeforces Round #290 (Div. 2) C. Fox And Names 拓扑排序

C. Fox And Names time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Fox Ciel is going to publish a paper on FOCS (Foxes Operated Computer Systems, pronounce: "Fox"). She heard a rumor: t

Codeforces Round #290 (Div. 2)

A题: 简单的模拟. 贴样例就知道了. input 3 3 output ###..#### input 3 4 output ####...##### input 5 3 output ###..#####..### input 9 9 output #########........###########........#########........###########........######### 1 #include<cstdio> 2 int main() 3 { 4 in

Codeforces Round #290 (Div. 2) B (dfs)

题目链接:http://codeforces.com/problemset/problem/510/B 题意:判断图中是否有某个字母成环 思路:直接dfs就好了,注意判断条件:若下一个字母与当前字母相同且已搜过,则存在满足题意的环 代码: 1 #include <bits/stdc++.h> 2 #define MAXN 60 3 using namespace std; 4 5 int mp[MAXN][MAXN], vis[MAXN][MAXN], m, n; 6 int dir[4][2

Codeforces Round #290 (Div. 2) 解题报告 A.B.C.D.

A - Fox And Snake 模拟. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm> #include <stdlib.h> #include <map> #include <set> #include <stdio.h> using na

Codeforces Round #290 (Div. 2) 拓扑排序

C. Fox And Names time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Fox Ciel is going to publish a paper on FOCS (Foxes Operated Computer Systems, pronounce: "Fox"). She heard a rumor: t

Codeforces Round #290 (Div. 2) B. Fox And Two Dots(DFS)

http://codeforces.com/problemset/problem/510/B #include "cstdio" #include "cstring" int r,c; char map[55][55]; int vis[55][55]; int mark; int dx[4]={1,-1,0,0},dy[4]={0,0,1,-1}; int judge(int x,int y) { if(x<0||x>=r||y<0||y>

#290 (div.2) D. Fox And Jumping

1.题目描述:点击打开链接 2.解题思路:本题利用扫描与维护解决.根据题意,能够走到所有的格子,一定是挑选出来的牌的步数的最大公约是1,这点很好理解.因为ax+by=1意味着只要有a个x和b个y就可以凑出来步数1.这样以来,只需要利用map来存储所有的公约数对应的最小费用即可.初始时刻base[0]=0,接下来就是从前往后扫描一遍这n个数,然后依次更新base中的每一个最大公约是对应的最小费用即可. 3.代码: #define _CRT_SECURE_NO_WARNINGS #include<i

#290 (div.2) B. Fox And Two Dots

1.题目描述:点击打开链接 2.解题思路:本题利用DFS来解决.本题要求判断一个图中是否存在相同颜色的圈.显然需要利用DFS来寻找.那么该如何寻找呢?题目中已经告诉了我们如何判断一个圈.那么只用根据题意描述来写DFS即可.从没有搜索过的结点开始,每次都找与它相邻的且颜色相同的结点来扩展,此时为了防止重复扩展,需要在DFS参数列表中加上前驱结点.这样以来,一旦发现某一个结点曾经已经标记过,说明找到了一个圈.直接输出Yes并退出循环. 3.代码: #define _CRT_SECURE_NO_WAR